<template>
  <div class="form">
    <form @submit="submit">
      <div class="form-group">
        <label>Siapa nama Anda?</label>
        <div>
          <input
            type="text"
            v-model="v$.form.firstname.$model"
            placeholder="Nama"
            class="input"
          />
          <div
            class="input-errors"
            v-for="(error, index) of v$.form.firstname.$errors"
            :key="index"
          >
            <div class="error-msg">{{ error.$message }}</div>
          </div>
        </div>
      </div>

      <div class="form-group">
        <label>Apa alamat email Anda?</label>
        <div>
          <input
            type="email"
            class="input"
            v-model="v$.form.email.$model"
            placeholder="Alamat Email"
          />
          <div
            class="input-errors"
            v-for="(error, index) of v$.form.email.$errors"
            :key="index"
          >
            <div class="error-msg">{{ error.$message }}</div>
          </div>
        </div>
      </div>

      <div class="form-group">
        <label>Apa pesan yang ingin Anda sampaikan?</label>
        <div>
          <textarea
            v-model="v$.form.note.$model"
            placeholder="Tulis pesan Anda di sini ..."
            class="input"
          ></textarea>
          <div
            class="input-errors"
            v-for="(error, index) of v$.form.note.$errors"
            :key="index"
          >
            <div class="error-msg">{{ error.$message }}</div>
          </div>
        </div>
      </div>

      <div v-if="alert.show" class="alert" :class="alert.type">
        {{ alert.message }}
      </div>

      <div class="form-group text-center">
        <button>Submit</button>
      </div>
    </form>
  </div>
</template>

<script>
import axios from "axios";
import { ref } from "vue";
import { useVuelidate } from "@vuelidate/core";
import { required, email, minLength, maxLength } from "@vuelidate/validators";

export function validName(name) {
  let validNamePattern = new RegExp("^[a-zA-Z]+(?:[-'\\s][a-zA-Z]+)*$");
  if (validNamePattern.test(name)) {
    return true;
  }
  return false;
}

export default {
  components: { },
  setup() {
    const isOpen = ref(false);

    return { v$: useVuelidate(), isOpen };
  },
  data() {
    return {
      alert: {
        show: false,
        type: "",
        message: "",
      },
      form: {
        firstname: "",
        email: "",
        note: "",
      },
    };
  },
  validations() {
    return {
      form: {
        firstname: {
          required,
          min: minLength(3),
          max: maxLength(10),
          name_validation: {
            $validator: validName,
            $message:
              "Invalid Name. Valid name only contain letters, dashes (-) and spaces",
          },
        },
        email: { required, email },
        note: { required },
      },
    };
  },
  methods: {
    async submit(event) {
      event.preventDefault();
      this.v$.$validate(); // checks all inputs
      if (!this.v$.$error) {
        const submitData = await axios
          .post(
            "https://mtarget-d0r.mailtrgt.com/form/6334036938709d00011d83c7",
            {
              firstname: this.form.firstname,
              email: this.form.email,
              note: this.form.note,
            }
          )
          .then((response) => {
            if (response.data) {
              this.form.firstname = "";
              this.form.email = "";
              this.form.note = "";
              this.alert.show = true;
              this.alert.message = "Data berhasil disimpan";
              this.alert.type = "alert-success";
            }
          })
          .catch((error) => {
            this.alert.show = true;
            this.alert.message = error.message;
            this.alert.type = "alert-warning";
          });
      }
    },
  },
};
</script>

<style scoped>
.form {
  width: 50%;
  margin: 20px auto 50px;
  padding: 20px;
}
.input {
  width: 100%;
  border: 1px solid var(--color-border);
  padding: 10px;
  border-radius: 9px;
}
.input:hover {
  border: 1px solid var(--color-border-hover);
}
.input:focus {
  outline: 1px solid var(--color-outline-hover);
}
.form-group {
  margin: 10px 0px;
}
button {
  background-color: var(--vt-c-green);
  border: none;
  padding: 10px;
  border-radius: 5px;
  cursor: pointer;
  color: white;
  margin: 10px auto;
}
.text-center {
  text-align: center;
}
.input-errors {
  padding: 5px 10px;
}
.error-msg {
  font-size: 0.875em;
  color: #dc3545;
}
.alert {
  width: 100%;
  padding: 1rem;
  border: 1px solid;
  border-radius: 0.375rem;
}
.alert-success {
  color: #0f5132;
  background: #d1e7dd;
  border-color: #badbcc;
}
.alert-warning {
  color: #664d03;
  background: #fff3cd;
  border-color: #ffecb5;
}
</style>
